const menuTrigger = document.querySelectorAll('[open-btn]');
const mobileMenu = document.querySelectorAll('[data-show]');
const closeTrigger = document.querySelectorAll('[close-btn]');
const overlay = document.querySelector('[data-overlay]');

for (let x = 0; x < menuTrigger.length; x++){
    const closeMenu = function(){
        mobileMenu[x].classList.remove('active');
        overlay.classList.remove('active');
    }
    menuTrigger[x].addEventListener('click', function() {
        mobileMenu[x].classList.add('active');
        overlay.classList.add('active');
    })
    closeTrigger[x].addEventListener('click', closeMenu);
    overlay.addEventListener('click', closeMenu)
}

//submenu
const submenu = document.querySelectorAll('.sub-trigger');
    submenu.forEach((menu) => menu.addEventListener('click', toggle));

    function toggle(){
        submenu.forEach((item) => item != this ? item.classList.remove('expand') : null);
        if(this.classList != 'expand'){
            this.classList.toggle('expand')
        }
    }

//progress
function progressBar(progressBarNum, progressStart, progressEnd, speed) {

    let progressBar = document.querySelector('.progress-bar-' + progressBarNum);
    let progressValue = document.querySelector('.progress-value-' + progressBarNum);

    let progress = setInterval(() => {
        progressStart ++;
        progressValue.textContent = `${progressStart}%`
        progressBar.style.background = `conic-gradient(red ${progressStart * 3.6}deg, lightgray 0deg)`

        if(progressStart == progressEnd){
            clearInterval(progress);
        }
    }, speed)

    return progress
}
progressBar(1, 0, 34, 200);
progressBar(2, 0, 6, 300);
progressBar(3, 0, 9 ,400);
progressBar(4, 0, 2, 500);
progressBar(5, 0, 3, 400); 
progressBar(6, 0, 1, 300);
progressBar(7, 0, 38, 200);
progressBar(8, 0, 7, 200);

//slider
const swiper = new Swiper('.swiper', {
    slidesPerView: 1,
    spaceBetween: 30,
    autoHeight: true,
    loop: true,
    breakpoints:{
        992:{
            slidesPerView: 3,
            centeredSlides: true,
        },
        641:{
            slidesPerView: 2,
            centeredSlides: false,
        }
    },
    pagination: {
      el: '.pagination',
    },
    navigation: {
      nextEl: '.button-next',
      prevEl: '.button-prev',
    },
  });

//accordion
const questions = document.querySelectorAll('.question-answ');
    questions.forEach(function(question){
        const btn = question.querySelector('.question-btn');
        btn.addEventListener("click", function(){
            questions.forEach(function(item){
                if(item !== question){
                    item.classList.remove('show-text');
                }
            })
            question.classList.toggle('show-text');
        })
    }) 

//chatbot
const sendBtn = document.querySelector(".chat-input span");
const chatInput = document.querySelector(".chat-input textarea");
const chatbox = document.querySelector(".chatbox");
const chatbotToggler = document.querySelector(".chatbot-toggler");
const chatbotCloseBtn = document.querySelector(".chatbot-close-btn");

let userMessage;
const api_key = "API KEY";
const inputHeight = chatInput.scrollHeight;

const createChat = (message, className) => {
    const chat_ = document.createElement("li");
    chat_.classList.add("chat", className);
    let chatContent =  className === "outgoing" ? `<p></p>`:`<span class="chatbot-icon"><i class='bx bx-bot'></i></span><p></p>`;
    chat_.innerHTML = chatContent;
    chat_.querySelector("p").textContent = message;
    return chat_;
}
const generateRespond = (incomingChat_) => {
    const api_url = "https://api.openai.com/v1/chat/completions";
    const messageElement = incomingChat_.querySelector("p");

    const requestOptions = {
        method: "POST",
        headers: {
            "Content-Type": "application/json",
            "Authorization": `Bearer ${api_key}`
        },
        body:JSON.stringify({
            model: "gpt-3.5-turbo",
            messages: [{role: "user", content: userMessage}]
        })
    }
    fetch(api_url, requestOptions).then(res => res.json()).then(data => {
        messageElement.textContent = data.choices[0].message.content;
    }).catch((error) => {
        messageElement.classList.add("error");
        messageElement.textContent = "Something went wrong, please try again!";
    }).finally(() => chatbox.scrollTo(0, chatbox.scrollHeight));
}

const handleChat = () =>{
    userMessage = chatInput.value.trim();
    if(!userMessage) return;
    chatInput.value = "";
    chatInput.style.height = `${inputHeight}px`

    chatbox.appendChild(createChat(userMessage, "outgoing"));
    chatbox.scrollTo(0, chatbox.scrollHeight);

    setTimeout (() => {
        const incomingChat_  = createChat("Typing...", "incoming")
        chatbox.appendChild(incomingChat_);
        chatbox.scrollTo(0, chatbox.scrollHeight);
        generateRespond(incomingChat_);
    }, 600);
}
chatInput.addEventListener("input", () => {
    chatInput.style.height = `${inputHeight}px`
    chatInput.style.height = `${chatInput.scrollHeight}px`
});

chatInput.addEventListener("keydown", (x) => {
    if(x.key ===  "Enter" && !x.shiftKey && window.innerWidth > 490){
        x.preventDefault();
        handleChat();
    }
});

sendBtn.addEventListener("click", handleChat);
chatbotToggler.addEventListener("click", () => document.body.classList.toggle("show-chatbot"));
chatbotCloseBtn.addEventListener("click", () => document.body.classList.remove("show-chatbot"));

